Main Page | Namespace List | Class Hierarchy | Alphabetical List | Class List | Directories | File List | Namespace Members | Class Members | File Members | Related Pages

# Ogre::DefaultHardwareBufferManager Class Reference

Specialisation of HardwareBufferManager to emulate hardware buffers. More...

`#include <OgreDefaultHardwareBufferManager.h>`

Inheritance diagram for Ogre::DefaultHardwareBufferManager:

[legend]
List of all members.

## Public Types
enum | BufferLicenseType { BLT_MANUAL_RELEASE, BLT_AUTOMATIC_RELEASE }
## Public Member Functions
| DefaultHardwareBufferManager ()
| ~DefaultHardwareBufferManager ()
HardwareVertexBufferSharedPtr | createVertexBuffer (size_t vertexSize, size_t numVerts, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Creates a vertex buffer.
HardwareIndexBufferSharedPtr | createIndexBuffer (HardwareIndexBuffer::IndexType itype, size_t numIndexes, HardwareBuffer::Usage usage, bool useShadowBuffer=false)
| Create a hardware vertex buffer.
virtual VertexDeclaration * | createVertexDeclaration (void)
| Creates a new vertex declaration.
virtual void | destroyVertexDeclaration (VertexDeclaration *decl)
| Destroys a vertex declaration.
virtual VertexBufferBinding * | createVertexBufferBinding (void)
| Creates a new VertexBufferBinding.
virtual void | destroyVertexBufferBinding (VertexBufferBinding *binding)
| Destroys a VertexBufferBinding.
virtual void | registerVertexBufferSourceAndCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, const HardwareVertexBufferSharedPtr &copy)
| Registers a vertex buffer as a copy of another.
virtual HardwareVertexBufferSharedPtr | allocateVertexBufferCopy (const HardwareVertexBufferSharedPtr &sourceBuffer, BufferLicenseType licenseType, HardwareBufferLicensee *licensee, bool copyData=false)
| Allocates a copy of a given vertex buffer.
virtual void | releaseVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Manually release a vertex buffer copy for others to subsequently use.
virtual void | touchVertexBufferCopy (const HardwareVertexBufferSharedPtr &bufferCopy)
| Tell engine that the vertex buffer copy intent to reuse.
virtual void | _freeUnusedBufferCopies (void)
| Free all unused vertex buffer copies.
virtual void | _releaseBufferCopies (bool forceFreeUnused=false)
| Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE.
virtual void | _forceReleaseBufferCopies (const HardwareVertexBufferSharedPtr &sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
virtual void | _forceReleaseBufferCopies (HardwareVertexBuffer *sourceBuffer)
| Internal method that forces the release of copies of a given buffer.
void | _notifyVertexBufferDestroyed (HardwareVertexBuffer *buf)
| Notification that a hardware vertex buffer has been destroyed.
void | _notifyIndexBufferDestroyed (HardwareIndexBuffer *buf)
| Notification that a hardware index buffer has been destroyed.
## Static Public Member Functions
static HardwareBufferManager & | getSingleton (void)
| Override standard Singleton retrieval.
static HardwareBufferManager * | getSingletonPtr (void)
| Override standard Singleton retrieval.
## Protected Types
typedef std::set< HardwareVertexBuffer * > | VertexBufferList
| WARNING: The following two members should place before all other members.
typedef std::set< HardwareIndexBuffer * > | IndexBufferList
typedef std::set< VertexDeclaration * > | VertexDeclarationList
typedef std::set< VertexBufferBinding * > | VertexBufferBindingList
typedef std::multimap< HardwareVertexBuffer *, HardwareVertexBufferSharedPtr > | FreeTemporaryVertexBufferMap
| Map from original buffer to temporary buffers.
typedef std::map< HardwareVertexBuffer *, VertexBufferLicense > | TemporaryVertexBufferLicenseMap
| Map from temporary buffer to details of a license.
## Protected Member Functions
virtual void | destroyAllDeclarations (void)
| Internal method for destroys all vertex declarations.
virtual void | destroyAllBindings (void)
| Internal method for destroys all vertex buffer bindings.
virtual VertexDeclaration * | createVertexDeclarationImpl (void)
| Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs.
virtual void | destroyVertexDeclarationImpl (VertexDeclaration *decl)
| Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs.
virtual VertexBufferBinding * | createVertexBufferBindingImpl (void)
| Internal method for creates a new VertexBufferBinding, may be overridden by certain rendering APIs.
virtual void | destroyVertexBufferBindingImpl (VertexBufferBinding *binding)
| Internal method for destroys a VertexBufferBinding, may be overridden by certain rendering APIs.
HardwareVertexBufferSharedPtr | makeBufferCopy (const HardwareVertexBufferSharedPtr &source, HardwareBuffer::Usage usage, bool useShadowBuffer)
| Creates a new buffer as a copy of the source, does not copy data.
## Protected Attributes
VertexBufferList | mVertexBuffers
IndexBufferList | mIndexBuffers
VertexDeclarationList | mVertexDeclarations
VertexBufferBindingList | mVertexBufferBindings
FreeTemporaryVertexBufferMap | mFreeTempVertexBufferMap
| Map of current available temp buffers.
TemporaryVertexBufferLicenseMap | mTempVertexBufferLicenses
| Map of currently licensed temporary buffers.
size_t | mUnderUsedFrameCount
| Number of frames elapsed since temporary buffers utilization was above half the available.
## Static Protected Attributes
static const size_t | UNDER_USED_FRAME_THRESHOLD
| Number of frames to wait before free unused temporary buffers.
static const size_t | EXPIRED_DELAY_FRAME_THRESHOLD
| Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers.
static HardwareBufferManager * | ms_Singleton

## Detailed Description

Specialisation of HardwareBufferManager to emulate hardware buffers.

Remarks:
  You might want to instantiate this class if you want to utilise classes like MeshSerializer without having initialised the rendering system (which is required to create a 'real' hardware buffer manager.

Definition at line 97 of file OgreDefaultHardwareBufferManager.h.

## Member Typedef Documentation

typedef std::multimap<HardwareVertexBuffer*, HardwareVertexBufferSharedPtr> Ogre::HardwareBufferManager::FreeTemporaryVertexBufferMap`[protected, inherited]`

| Map from original buffer to temporary buffers. Definition at line 173 of file OgreHardwareBufferManager.h.

typedef std::set<HardwareIndexBuffer*> Ogre::HardwareBufferManager::IndexBufferList`[protected, inherited]`

| Definition at line 106 of file OgreHardwareBufferManager.h.

typedef std::map<HardwareVertexBuffer*, VertexBufferLicense> Ogre::HardwareBufferManager::TemporaryVertexBufferLicenseMap`[protected, inherited]`

| Map from temporary buffer to details of a license. Definition at line 177 of file OgreHardwareBufferManager.h.

typedef std::set<VertexBufferBinding*> Ogre::HardwareBufferManager::VertexBufferBindingList`[protected, inherited]`

| Definition at line 112 of file OgreHardwareBufferManager.h.

typedef std::set<HardwareVertexBuffer*> Ogre::HardwareBufferManager::VertexBufferList`[protected, inherited]`

| WARNING: The following two members should place before all other members. Members destruct order is very important here, because destructing other members will cause notify back to this class, and then will access to this two members. Definition at line 105 of file OgreHardwareBufferManager.h.

typedef std::set<VertexDeclaration*> Ogre::HardwareBufferManager::VertexDeclarationList`[protected, inherited]`

| Definition at line 111 of file OgreHardwareBufferManager.h.

## Member Enumeration Documentation

enum Ogre::HardwareBufferManager::BufferLicenseType`[inherited]`

  | Enumeration values:
  BLT_MANUAL_RELEASE | Licensee will only release buffer when it says so.
  BLT_AUTOMATIC_RELEASE | Licensee can have license revoked.
Definition at line 139 of file OgreHardwareBufferManager.h.

## Constructor & Destructor Documentation

Ogre::DefaultHardwareBufferManager::DefaultHardwareBufferManager | ( |  | ) |

Ogre::DefaultHardwareBufferManager::~DefaultHardwareBufferManager | ( |  | ) |

## Member Function Documentation

virtual void Ogre::HardwareBufferManager::_forceReleaseBufferCopies | ( | HardwareVertexBuffer * | sourceBuffer | ) | `[virtual, inherited]`

  | Internal method that forces the release of copies of a given buffer. Remarks: This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes. Parameters:
  | sourceBuffer | the source buffer as a pointer. Any buffer copies created from the source buffer are deleted.

virtual void Ogre::HardwareBufferManager::_forceReleaseBufferCopies | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer | ) | `[virtual, inherited]`

  | Internal method that forces the release of copies of a given buffer. Remarks: This usually means that the buffer which the copies are based on has been changed in some fundamental way, and the owner of the original wishes to make that known so that new copies will reflect the changes. Parameters:
  | sourceBuffer | the source buffer as a shared pointer. Any buffer copies created from the source buffer are deleted.

virtual void Ogre::HardwareBufferManager::_freeUnusedBufferCopies | ( | void |  | ) | `[virtual, inherited]`

| Free all unused vertex buffer copies. Remarks: This method free all temporary vertex buffers that not in used. In normally, temporary vertex buffers are subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. But in some cases you want to free them to save hardware memory (e.g. application was runs in a long time, you might free temporary buffers periodically to avoid memory overload).

void Ogre::HardwareBufferManager::_notifyIndexBufferDestroyed | ( | HardwareIndexBuffer * | buf | ) | `[inherited]`

| Notification that a hardware index buffer has been destroyed.

void Ogre::HardwareBufferManager::_notifyVertexBufferDestroyed | ( | HardwareVertexBuffer * | buf | ) | `[inherited]`

| Notification that a hardware vertex buffer has been destroyed.

virtual void Ogre::HardwareBufferManager::_releaseBufferCopies | ( | bool | forceFreeUnused = `false` | ) | `[virtual, inherited]`

  | Internal method for releasing all temporary buffers which have been allocated using BLT_AUTOMATIC_RELEASE; is called by OGRE. Parameters:
  | forceFreeUnused | If true, free all unused temporary buffers. If false, auto detect and free all unused temporary buffers based on temporary buffers utilization.

virtual HardwareVertexBufferSharedPtr Ogre::HardwareBufferManager::allocateVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | BufferLicenseType | licenseType,
|  | HardwareBufferLicensee * | licensee,
|  | bool | copyData = `false`
| ) | `[virtual, inherited]`

  | Allocates a copy of a given vertex buffer. Remarks: This method allocates a temporary copy of an existing vertex buffer. This buffer is subsequently stored and can be made available for other purposes later without incurring the cost of construction / destruction. Parameters:
  | sourceBuffer | The source buffer to use as a copy
  | licenseType | The type of license required on this buffer - automatic release causes this class to release licenses every frame so that they can be reallocated anew.
  | licensee | Pointer back to the class requesting the copy, which must implement HardwareBufferLicense in order to be notified when the license expires.
  | copyData | If true, the current data is copied as well as the structure of the buffer

HardwareIndexBufferSharedPtr Ogre::DefaultHardwareBufferManager::createIndexBuffer | ( | HardwareIndexBuffer::IndexType | itype,
|  | size_t | numIndexes,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false`
| ) | `[virtual]`

| Create a hardware vertex buffer. Implements Ogre::HardwareBufferManager.

HardwareVertexBufferSharedPtr Ogre::DefaultHardwareBufferManager::createVertexBuffer | ( | size_t | vertexSize,
|  | size_t | numVerts,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer = `false`
| ) | `[virtual]`

| Creates a vertex buffer. Implements Ogre::HardwareBufferManager.

virtual VertexBufferBinding* Ogre::HardwareBufferManager::createVertexBufferBinding | ( | void |  | ) | `[virtual, inherited]`

| Creates a new VertexBufferBinding.

virtual VertexBufferBinding* Ogre::HardwareBufferManager::createVertexBufferBindingImpl | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method for creates a new VertexBufferBinding, may be overridden by certain rendering APIs.

virtual VertexDeclaration* Ogre::HardwareBufferManager::createVertexDeclaration | ( | void |  | ) | `[virtual, inherited]`

| Creates a new vertex declaration.

virtual VertexDeclaration* Ogre::HardwareBufferManager::createVertexDeclarationImpl | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method for creates a new vertex declaration, may be overridden by certain rendering APIs.

virtual void Ogre::HardwareBufferManager::destroyAllBindings | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method for destroys all vertex buffer bindings.

virtual void Ogre::HardwareBufferManager::destroyAllDeclarations | ( | void |  | ) | `[protected, virtual, inherited]`

| Internal method for destroys all vertex declarations.

virtual void Ogre::HardwareBufferManager::destroyVertexBufferBinding | ( | VertexBufferBinding * | binding | ) | `[virtual, inherited]`

| Destroys a VertexBufferBinding.

virtual void Ogre::HardwareBufferManager::destroyVertexBufferBindingImpl | ( | VertexBufferBinding * | binding | ) | `[protected, virtual, inherited]`

| Internal method for destroys a VertexBufferBinding, may be overridden by certain rendering APIs.

virtual void Ogre::HardwareBufferManager::destroyVertexDeclaration | ( | VertexDeclaration * | decl | ) | `[virtual, inherited]`

| Destroys a vertex declaration.

virtual void Ogre::HardwareBufferManager::destroyVertexDeclarationImpl | ( | VertexDeclaration * | decl | ) | `[protected, virtual, inherited]`

| Internal method for destroys a vertex declaration, may be overridden by certain rendering APIs.

static HardwareBufferManager& Ogre::HardwareBufferManager::getSingleton | ( | void |  | ) | `[static, inherited]`

| Override standard Singleton retrieval. Remarks: Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. Reimplemented from Ogre::Singleton< HardwareBufferManager >.

static HardwareBufferManager* Ogre::HardwareBufferManager::getSingletonPtr | ( | void |  | ) | `[static, inherited]`

| Override standard Singleton retrieval. Remarks: Why do we do this? Well, it's because the Singleton implementation is in a .h file, which means it gets compiled into anybody who includes it. This is needed for the Singleton template to work, but we actually only want it compiled into the implementation of the class based on the Singleton, not all of them. If we don't change this, we get link errors when trying to use the Singleton-based class from an outside dll. This method just delegates to the template version anyway, but the implementation stays in this single compilation unit, preventing link errors. Reimplemented from Ogre::Singleton< HardwareBufferManager >.

HardwareVertexBufferSharedPtr Ogre::HardwareBufferManager::makeBufferCopy | ( | const HardwareVertexBufferSharedPtr & | source,
|  | HardwareBuffer::Usage | usage,
|  | bool | useShadowBuffer
| ) | `[protected, inherited]`

| Creates a new buffer as a copy of the source, does not copy data.

virtual void Ogre::HardwareBufferManager::registerVertexBufferSourceAndCopy | ( | const HardwareVertexBufferSharedPtr & | sourceBuffer,
|  | const HardwareVertexBufferSharedPtr & | copy
| ) | `[virtual, inherited]`

| Registers a vertex buffer as a copy of another. Remarks: This is useful for registering an existing buffer as a temporary buffer which can be allocated just like a copy.

virtual void Ogre::HardwareBufferManager::releaseVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

  | Manually release a vertex buffer copy for others to subsequently use. Remarks: Only required if the original call to allocateVertexBufferCopy included a licenseType of BLT_MANUAL_RELEASE. Parameters:
  | bufferCopy | The buffer copy. The caller is expected to delete or at least no longer use this reference, since another user may well begin to modify the contents of the buffer.

virtual void Ogre::HardwareBufferManager::touchVertexBufferCopy | ( | const HardwareVertexBufferSharedPtr & | bufferCopy | ) | `[virtual, inherited]`

  | Tell engine that the vertex buffer copy intent to reuse. Remarks: Ogre internal keep an expired delay counter of BLT_AUTOMATIC_RELEASE buffers, when the counter count down to zero, it'll release for other purposes later. But you can use this function to reset the counter to the internal configured value, keep the buffer not get released for some frames. Parameters:
  | bufferCopy | The buffer copy. The caller is expected to keep this buffer copy for use.

## Member Data Documentation

const size_t Ogre::HardwareBufferManager::EXPIRED_DELAY_FRAME_THRESHOLD`[static, protected, inherited]`

| Frame delay for BLT_AUTOMATIC_RELEASE temporary buffers. Definition at line 185 of file OgreHardwareBufferManager.h.

FreeTemporaryVertexBufferMap Ogre::HardwareBufferManager::mFreeTempVertexBufferMap`[protected, inherited]`

| Map of current available temp buffers. Definition at line 175 of file OgreHardwareBufferManager.h.

IndexBufferList Ogre::HardwareBufferManager::mIndexBuffers`[protected, inherited]`

| Definition at line 108 of file OgreHardwareBufferManager.h.

HardwareBufferManager * Ogre::Singleton< HardwareBufferManager >::ms_Singleton`[static, protected, inherited]`

| Definition at line 61 of file OgreSingleton.h.

TemporaryVertexBufferLicenseMap Ogre::HardwareBufferManager::mTempVertexBufferLicenses`[protected, inherited]`

| Map of currently licensed temporary buffers. Definition at line 179 of file OgreHardwareBufferManager.h.

size_t Ogre::HardwareBufferManager::mUnderUsedFrameCount`[protected, inherited]`

| Number of frames elapsed since temporary buffers utilization was above half the available. Definition at line 181 of file OgreHardwareBufferManager.h.

VertexBufferBindingList Ogre::HardwareBufferManager::mVertexBufferBindings`[protected, inherited]`

| Definition at line 114 of file OgreHardwareBufferManager.h.

VertexBufferList Ogre::HardwareBufferManager::mVertexBuffers`[protected, inherited]`

| Definition at line 107 of file OgreHardwareBufferManager.h.

VertexDeclarationList Ogre::HardwareBufferManager::mVertexDeclarations`[protected, inherited]`

| Definition at line 113 of file OgreHardwareBufferManager.h.

const size_t Ogre::HardwareBufferManager::UNDER_USED_FRAME_THRESHOLD`[static, protected, inherited]`

| Number of frames to wait before free unused temporary buffers. Definition at line 183 of file OgreHardwareBufferManager.h.

The documentation for this class was generated from the following file:

- OgreDefaultHardwareBufferManager.h

Copyright © 2000-2005 by The OGRE Team
This work is licensed under a Creative Commons Attribution-ShareAlike 2.5 License.
Last modified Thu Mar 6 09:46:41 2008